/*
 * STDDEF.H	standard definitions
 * 
 * you won't have to include this file explicitly, cause it is included by
 * stdlib.h/stdio.h. and via types.h
 * -jerry-
 */

#ifndef STDDEF_H
#define STDDEF_H

//#define	dLibs		(0x1200)	/* dLibs identifier (also vsn #) */

#define _XDLIBS		0x102	/* XDLIBS identifier, there is an
				variable _xdlibs in library with the same value:	*/ 
extern	int _xdlibs;

#ifndef	NULL
#define	NULL		(void *)0L	/* void pointer	*/
#endif

#ifndef	FALSE
#define	FALSE	0
#endif

#ifndef TRUE
#define	TRUE	1
#endif

#ifndef NIL
#define	NIL	-1
#endif

#ifdef	size_t
//#error "you shouldn't redefine this type"
#else
typedef	unsigned int	size_t;		/* sizeof() value type */
#endif


typedef	long		ptrdiff_t;	/* pointer subtraction result type */

/* offset in bytes of 'membr' in structure 'Typ' */
#define offsetof(T,m) \
	((size_t) (((char *) &(((T *) 256)->m)) - ((char *) ((T *) 256))))
//#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

#endif STDDEF_H
